run.sh 1.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778
  1. #!/bin/bash
  2. # Copyright (c) 2020 Linaro Limited
  3. #
  4. # SPDX-License-Identifier: Apache-2.0
  5. set -eE
  6. function cleanup()
  7. {
  8. # Rename twister junit xml for use with junit-annotate-buildkite-plugin
  9. # create dummy file if twister did nothing
  10. if [ ! -f twister-out/twister.xml ]; then
  11. touch twister-out/twister.xml
  12. fi
  13. mv twister-out/twister.xml twister-${BUILDKITE_JOB_ID}.xml
  14. buildkite-agent artifact upload twister-${BUILDKITE_JOB_ID}.xml
  15. # Upload test_file to get list of tests that are build/run
  16. if [ -f test_file.txt ]; then
  17. buildkite-agent artifact upload test_file.txt
  18. fi
  19. # ccache stats
  20. echo "--- ccache stats at finish"
  21. ccache -s
  22. # Cleanup on exit
  23. rm -fr *
  24. # disk usage
  25. echo "--- disk usage at finish"
  26. df -h
  27. }
  28. trap cleanup ERR
  29. echo "--- run $0"
  30. git log -n 5 --oneline --decorate --abbrev=12
  31. # Setup module cache
  32. cd /workdir
  33. ln -s /var/lib/buildkite-agent/zephyr-module-cache/modules
  34. ln -s /var/lib/buildkite-agent/zephyr-module-cache/tools
  35. ln -s /var/lib/buildkite-agent/zephyr-module-cache/bootloader
  36. cd /workdir/zephyr
  37. export JOB_NUM=$((${BUILDKITE_PARALLEL_JOB}+1))
  38. # ccache stats
  39. echo ""
  40. echo "--- ccache stats at start"
  41. ccache -s
  42. if [ -n "${DAILY_BUILD}" ]; then
  43. TWISTER_OPTIONS=" --inline-logs -M -N --build-only --all --retry-failed 3 -v "
  44. echo "--- DAILY BUILD"
  45. west init -l .
  46. west update 1> west.update.log || west update 1> west.update-2.log
  47. west forall -c 'git reset --hard HEAD'
  48. source zephyr-env.sh
  49. ./scripts/twister --subset ${JOB_NUM}/${BUILDKITE_PARALLEL_JOB_COUNT} ${TWISTER_OPTIONS}
  50. else
  51. if [ -n "${BUILDKITE_PULL_REQUEST_BASE_BRANCH}" ]; then
  52. ./scripts/ci/run_ci.sh -c -b ${BUILDKITE_PULL_REQUEST_BASE_BRANCH} -r origin \
  53. -m ${JOB_NUM} -M ${BUILDKITE_PARALLEL_JOB_COUNT} -p ${BUILDKITE_PULL_REQUEST}
  54. else
  55. ./scripts/ci/run_ci.sh -c -b ${BUILDKITE_BRANCH} -r origin \
  56. -m ${JOB_NUM} -M ${BUILDKITE_PARALLEL_JOB_COUNT};
  57. fi
  58. fi
  59. TWISTER_EXIT_STATUS=$?
  60. cleanup
  61. exit ${TWISTER_EXIT_STATUS}